
setwd("C:/Users/rothe/Documents/My Dropbox/Papers/Misspecification Test for Conditional Distributional Models/Simulations")
##setwd("d:/benutzer/wied/dokumente/my dropbox/my dropbox/Misspecification test for conditional distributional models/simulations")

load("empirical.Rdata")

trim <- rbind(c(1e-7,1-1e-7),c(.1,.9),c(.1,.5),c(.5,.9))

quant<- function(m=5000,n=2000,q=3,qu1=0.05,qu2=0.95,empqu=0.95) {
 nvektor <- seq(0,1,by=1/n)
 zaehler <- rep(0,m)

 for(i in 1:m) {
  zuwaechse <- matrix(c(rnorm(n*q,0,sqrt(1/n))),ncol=q)
  wertebbew <- apply(zuwaechse,2,cumsum)
  teststat <- apply(wertebbew,1,function(x) sum(abs(x)))
  teststat <- max(teststat[(qu1*n):(qu2*n)])
  zaehler[i] <- teststat
 }
 quantil <- quantile(zaehler,empqu)
 return(quantil)
}


konker.cval <- list(NA)

for (i in 1:3) {
 konker.cval[[i]] <- matrix(0,ncol=4,nrow=2,dimnames=(list(c("5%","10%"),c("eps=0","2","3","4"))))
}



p <- c(3,9,30)

for (i in 1:3) {
 konker.cval[[i]] <- matrix(NA,ncol=4,nrow=2,dimnames=(list(c("5%","10%"),c("eps=0","2","3","4"))))
 for (j in 1:4) {
  for (k in 1:2) {
   konker.cval[[i]][k,j] <-  quant(m=5000,n=2000,q=p[i],qu1=trim[j,1],qu2=trim[j,2],empqu=c(.95,0.9)[k])
  }
 }
}

konker.cval 




## Anordnung der variablen wie im papier 


 outtable <- matrix(NA, ncol=14, nrow=3*2*4)
  
for (nval in 1:2) {
 for (trimval in 1:4) {
  for (model in 1:3) {
  
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,10] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[[model]][1,trimval],na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,9] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[[model]][2,trimval],na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,12] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[[model]][1,trimval],na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,11] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[[model]][2,trimval],na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,2] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,4]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,1] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,4]<=  .10,na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,4] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,6]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,3] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,6]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,6]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,8]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,5] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,8]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,8]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,10]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,7]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,10]<=  .10,na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,14]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,13]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .10,na.rm=TRUE)
  
  }
 }
}



round(outtable,2)

library(xtable)
dimnames(outtable)[[1]] <- rep(c("Model 1","Model 2","Model 3"),8)
tab <- xtable(outtable[12+1:3,1:8])
digits(tab) <- c(0,rep(3,8))
print(tab)



 
################################################################################
## CvM Test fr unsere Verfahren

 outtable <- matrix(NA, ncol=14, nrow=3*2*4)
  
for (nval in 1:2) {
 for (trimval in 1:4) {
  for (model in 1:3) {
  
   #  outtable[(nval-1)*3*4 + (trimval-1)*3 +model,1] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[[model]][1,trimval],na.rm=TRUE)
   #  outtable[(nval-1)*3*4 + (trimval-1)*3 +model,2] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[[model]][2,trimval],na.rm=TRUE)
   #  outtable[(nval-1)*3*4 + (trimval-1)*3 +model,3] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[[model]][1,trimval],na.rm=TRUE)
   #  outtable[(nval-1)*3*4 + (trimval-1)*3 +model,4] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[[model]][2,trimval],na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,5] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,4]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,6] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,4]<=  .10,na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,7] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,6]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,8] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,6]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,9]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,8]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,10] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,8]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,11]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,10]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,12]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,10]<=  .10,na.rm=TRUE)
     
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,13]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,14]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .10,na.rm=TRUE)
  
  }
 }
}



round(outtable,2)

################################################################################
## KS Test fr unsere Verfahren

outtable <- matrix(NA, ncol=14, nrow=2*2*6)

for (nval in 1:2) {
 for (trimval in 1:4) {
  for (model in 1:3) {

    # outtable[(nval-1)*3*4 + (trimval-1)*3 +model,1] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[1,trimval],na.rm=TRUE)
    # outtable[(nval-1)*3*4 + (trimval-1)*3 +model,2] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,1]>=  konker.cval[2,trimval],na.rm=TRUE)
     #outtable[(nval-1)*3*4 + (trimval-1)*3 +model,3] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[1,trimval],na.rm=TRUE)
    # outtable[(nval-1)*3*4 + (trimval-1)*3 +model,4] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,2]>=  konker.cval[2,trimval],na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,5] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,3]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,6] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,3]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,7] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,5]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,8] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,5]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,9]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,7]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,10] <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,7]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,11]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,9]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,12]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,9]<=  .10,na.rm=TRUE)

     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,13]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .05,na.rm=TRUE)
     outtable[(nval-1)*3*4 + (trimval-1)*3 +model,14]  <- mean(pval[[(nval-1)*3*4 + (trimval-1)*3 +model]][,12]<=  .10,na.rm=TRUE)

  }
 }
}



round(outtable,2)